#import "YoumePlugin.h"
//#import "YoumePlugin.h"
#import "YIMService.h"
#import "YIMClient.h"
//#import <IMMessageExt/IMMessageExt.h>
//#import <IMFriendshipExt/IMFriendshipExt.h>

@interface YoumePlugin() <YIMCallbackProtocol, FlutterStreamHandler>
@property (nonatomic, strong) FlutterEventSink eventSink;

@end

@implementation YoumePlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"youme_method"
            binaryMessenger:[registrar messenger]];
  YoumePlugin* instance = [[YoumePlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
    FlutterEventChannel *eventChannel = [FlutterEventChannel eventChannelWithName:@"youme_event" binaryMessenger:[registrar messenger]];
    [eventChannel setStreamHandler:instance];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if ([ @"init" isEqualToString:call.method] ){
      NSString *appKey = (NSString *)(call.arguments[@"appKey"]);
      NSString *appSecret = (NSString *)(call.arguments[@"appSecret"]);
      [[YIMClient GetInstance] InitWithAppKey:appKey
                               appSecurityKey:appSecret
                                serverZone:YouMeIMServerZone_China];
      //设置回调
      [[YIMClient GetInstance] SetDelegate:self];
      result(@"success");
//      NSLog(@"init sdk end %i", result);
  }else if([ @"login" isEqualToString:call.method] ){
      NSString *userId =  (NSString *)(call.arguments[@"userId"]);
      NSString *pwd =  (NSString *)(call.arguments[@"pwd"]);
      
      [[YIMClient GetInstance] Login:userId password:pwd token:@"" callback:^(YIMErrorcodeOC errorcode, NSString *userID) {
          
          if(errorcode == YouMeIMCode_Success){
              result(@"success");
              
          }else{
              result(@"failed");
          }
      }];
  }else if([ @"send_txt_msg" isEqualToString:call.method] ){
      NSString *receiverId =  (NSString *)(call.arguments[@"receiver"]);
      NSString *content =  (NSString *)(call.arguments[@"content"]);
      unsigned long long reqID=0;
      NSLog(@"消息 准备发送");
      reqID = [[YIMClient GetInstance] SendTextMessage: receiverId chatType:YIMChatType_PrivateChat msgContent:content callback:^(YIMErrorcodeOC errorcode, unsigned int sendTime, bool isForbidRoom, int reasonType, unsigned long long forbidEndTime) {
          NSLog(@"消息id：%lld 发送",reqID);
          if(errorcode ==YouMeIMCode_Success){
              NSLog(@"消息id：%lld 发送成功",reqID);
              result(@"success");
          }else{
              NSLog(@"发送文本消息失败，一般是没有登陆:%d",errorcode);
          }
      }];
      
      
  }
  
  else {
    result(FlutterMethodNotImplemented);
  }
}


//回调监听
- (void) OnLogin:(YIMErrorcodeOC) errorcode userID:(NSString*) userID{
    //    if(errorcode == YouMeIMCode_Success){
    //         NSLog(@"登陆成功，现在进入房间");
    //        [[YIMClient GetInstance] JoinChatRoom:@"room_w123"];
    //         [_tipsLabel setText:[NSString stringWithFormat:@"OnLogin成功"]];
    //    }else{
    //        NSLog(@"登陆失败，可以视情况重试登陆");
    //        [_tipsLabel setText:[NSString stringWithFormat:@"OnLogin失败:%d",errorcode]];
    //    }
}
- (void) OnLogout:(YIMErrorcodeOC) errorcode{
    NSLog(@"退出了，如果平台还在线，可以重试登陆");
}

- (void) OnKickOff{
    
}

//IYIMMessageCallback
- (void) OnSendMessageStatus:(unsigned long long) iRequestID errorcode:(YIMErrorcodeOC) errorcode  isForbidRoom:(bool) isForbidRoom   reasonType:(int)reasonType forbidEndTime:(unsigned long long)forbidEndTime{
    //    if(errorcode ==YouMeIMCode_Success){
    //        NSLog(@"消息id：%lld 发送成功",iRequestID);
    //    }
}

- (void) OnRecvMessage:(YIMMessage*) pMessage{
    //私聊消息 还是 房间消息的判断
    BOOL isPrivateMessage =( pMessage.chatType ==YIMChatType_PrivateChat) ;
    
    if(pMessage.messageBody.messageType == YIMMessageBodyType_TXT){
        //收到的是文本消息
        YIMMessageBodyText *tMessage = (YIMMessageBodyText *)pMessage.messageBody;
//        [_tipsLabel setText:[NSString stringWithFormat:@"%@,%@", @"收到文本消息", [tMessage messageContent] ] ];
        NSLog(@"文字消息:%@",[tMessage messageContent]);
        
//        result(jsonString);
        NSDictionary *msgDict = @{
                               @"senderId": pMessage.senderID,
                               @"content": tMessage.messageContent,
                               @"isPrivate": @true
                               };
        NSError *writeError = nil;
        NSData *jsonData = [NSJSONSerialization dataWithJSONObject:msgDict options:NSJSONWritingPrettyPrinted error:&writeError];
        NSString *jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
        self.eventSink(jsonString);
        
    }else if(pMessage.messageBody.messageType == YIMMessageBodyType_Voice){
        //收到的是语音消息
        YIMMessageBodyAudio *vMessage = (YIMMessageBodyAudio *)pMessage.messageBody;
        NSLog(@"文字识别结果:%@,fileSize:%d,audioTime:%d",[vMessage textContent], [vMessage fileSize], [vMessage audioTime] );
        //下载语音文件
//        [[YIMClient GetInstance] DownloadAudio:pMessage.messageID strSavePath:[ViewController createUniqFilePath] callback:^(YIMErrorcodeOC errorcode, YIMMessage *msg, NSString *savePath) {
//            _lastRecvAudioPath = savePath;
//        }];
    }
    else if (pMessage.messageBody.messageType == YIMMessageBodyType_File ){
        YIMMessageBodyFile* fileMsg = (YIMMessageBodyFile *)pMessage.messageBody;
        NSLog(@"获得文件:" );
        
        
        NSArray *cachePaths = NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES);
        NSString *cachePath = [cachePaths objectAtIndex:0];
        
        NSString *fullCachePath = [cachePath stringByAppendingPathComponent:@"YIMVoiceCache/file.txt"];
        
        //下载语音文件
        //pMessage.messageID
        [[YIMClient GetInstance] DownloadAudio:1 strSavePath:fullCachePath callback:^(YIMErrorcodeOC errorcode, YIMMessage *msg, NSString *savePath) {
            
        }];
        //        NSLog(@"down file :%d", code );
    }
    else if  (pMessage.messageBody.messageType == YIMMessageBodyType_Gift ){
        YIMMessageBodyGift* giftMsg = (YIMMessageBodyGift *)pMessage.messageBody;
        
        NSLog(@"获得礼物:%d,%d,anchor:%@,extraParam:%@", giftMsg.giftID, giftMsg.giftCount, giftMsg.anchor, giftMsg.extraParam );
    }
    else if ( pMessage.messageBody.messageType == YIMMessageBodyType_CustomMesssage ){
        YIMMessageBodyCustom* customMsg = (YIMMessageBodyCustom *)pMessage.messageBody;
        const char* cp = (const char*)customMsg.messageContent.bytes;
        int size = customMsg.messageContent.length;
        
        NSLog(@"获得自定义消息,size%d", size  );
    }
}

- (void) OnQueryHistoryMessage:(YIMErrorcodeOC) errorcode targetID:(NSString*) targetID  remain:(int) remain messageArray:( NSArray *) messageArray{
    NSLog(@"OnGetRecentContacts,count:%d", messageArray.count );
}

- (void) OnStopAudioSpeechStatus:(YIMErrorcodeOC) errorcode audioSpeechInfo:(AudioSpeechInfo*) audioSpeechInfo{
    //    NSLog(@"OnStopAudioSpeechStatus,error:%d,%@_%@", (int)errorcode, audioSpeechInfo.textContent, audioSpeechInfo.downloadURL );
}

- (void) OnGetRecentContacts:(YIMErrorcodeOC) errorcode contactArray:( NSArray *) contactArray{
    NSLog(@"OnGetRecentContacts,count:%d", contactArray.count );
}

//新消息通知（只有SetReceiveMessageSwitch设置为不自动接收消息，才会收到该回调）
- (void) OnReceiveMessageNotify:(YIMChatTypeOC)chatType targetID:(NSString*)targetID;{
    NSLog(@"OnReceiveMessageNotify,...........");
}

//停止语音回调（调用StopAudioMessage停止语音之后，发送语音消息之前）
- (void) OnStartSendAudioMessage:(unsigned long long) iRequestID errorcode:(YIMErrorcodeOC) errorcode
                      strMessage:(NSString*)strMessage strAudioPath:(NSString*) strAudioPath audioTime:(unsigned int)audioTime{
    
}

- (void) OnSendAudioMessageStatus:(unsigned long long) iRequestID errorcode:(YIMErrorcodeOC) errorcode
                       strMessage:(NSString*)strMessage strAudioPath:(NSString*) strAudioPath  audioTime:(unsigned)audioTime   isForbidRoom:(bool) isForbidRoom   reasonType:(int)reasonType forbidEndTime:(unsigned long long)forbidEndTime{
    //    if(errorcode == YouMeIMCode_Success){
    //        _lastSendAudioPath = strAudioPath;
    //        [_tipsLabel setText:@"语音发送成功"];
    //    }else{
    //        [_tipsLabel setText:[NSString stringWithFormat:@"语音发送失败:%d",errorcode]];
    //    }
}

//IYIMDownloadCallback
- (void) OnDownload:(YIMErrorcodeOC)errorcode  pMessage:(YIMMessage*) pMessage strSavePath:(NSString*)strSavePath
{
//    _lastRecvAudioPath = strSavePath;
}

- (void) OnDownloadByUrl:(YIMErrorcodeOC)errorcode strFromUrl:(NSString*)strFromUrl strSavePath:(NSString*)strSavePath{
//    _lastRecvAudioPath = strSavePath;
}


//进入房间的回调，JoinChatRoom也在这个回调
- (void) OnJoinRoom:(YIMErrorcodeOC) errorcode roomID:(NSString*) roomID{
    //    if(errorcode == YouMeIMCode_Success){
    //        NSLog(@"进入房间成功");
    //    }else{
    //        NSLog(@"进入房间失败，基本上不会：%d",errorcode);
    //    }
}

- (void) OnLeaveRoom:(YIMErrorcodeOC) errorcode roomID:(NSString*) roomID{
    
}


+(NSString*)createUniqFilePath{
    NSArray *cachePaths = NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES);
    NSString *cachePath = [cachePaths objectAtIndex:0];
    
    NSString *fullCachePath = [cachePath stringByAppendingPathComponent:@"YIMVoiceCache"];
    NSString *fileName = [NSString stringWithFormat:@"%@.wav", [[NSUUID UUID] UUIDString]];
    BOOL isDir = FALSE;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    BOOL isDirExist = [fileManager fileExistsAtPath:fullCachePath
                                        isDirectory:&isDir];
    if(!isDirExist){
        BOOL bCreateDir = [fileManager createDirectoryAtPath:fullCachePath
                                 withIntermediateDirectories:YES
                                                  attributes:nil
                                                       error:nil];
        
        if(!bCreateDir){
            
            NSLog(@"YIM Create Audio Cache Directory Failed.");
            
        }
        
        NSLog(@"%@",fullCachePath);
    }
    return [fullCachePath stringByAppendingPathComponent:fileName];
}

- (void) OnUserJoinRoom:(NSString*)roomId userID:(NSString*)userId
{
    
}
- (void) OnUserLeaveRoom:(NSString*)roomId userID:(NSString*)userId
{
    
}

// 接收公告
- (void) OnRecvNotice:(YIMNoticeOC*) notice
{
    
}
// 撤销公告（置顶公告）
- (void) OnCancelNotice:(unsigned long long) noticeID channelID:(NSString*)channelID
{
    
}

- (void) OnGetForbiddenSpeakInfo:(YIMErrorcodeOC)errorcode  forbiddenSpeakArray:(NSArray*) forbiddenSpeakArray
{
    
}

//IYIMAudioPlayCallback 播放回调
- (void) OnPlayCompletion:(YIMErrorcodeOC) errorcode  path:(NSString*) path
{
    
}
- (void) OnGetMicrophoneStatus:(AudioDeviceStatusOC)status
{
    
}


//IYIMLocationCallback 地理位置回调
// 获取自己位置回调
- (void) OnUpdateLocation:(YIMErrorcodeOC) errorcode  location:(GeographyLocationOC*) location{
    
}

// 获取附近目标回调neighbourList:(NSArray<RelativeLocationOC*>)
- (void) OnGetNearbyObjects:(YIMErrorcodeOC) errorcode neighbourList:(NSArray*) neighbourList  startDistance:(unsigned int) startDistance  endDistance:(unsigned int) endDistance {
    
}

//获取用户信息回调(用户信息为JSON格式)
- (void) OnGetUserInfo:(YIMErrorcodeOC)errorcode userID:(NSString*)userID userInfo:(NSString*) userInfo
{
    
}
//查询用户状态回调
- (void) OnQueryUserStatus:(YIMErrorcodeOC)errorcode userID:(NSString*)userID status:(YIMUserStatusOC) status
{
    
}


//文本翻译完成回调
- (void) OnTranslateTextComplete:(YIMErrorcodeOC) errorcode requestID:(unsigned int) requestID  text:(NSString*)text srcLangCode:(LanguageCodeOC) srcLangCode destLangCode:(LanguageCodeOC) destLangCode
{
    
}

// 举报处理结果通知
- (void)OnAccusationResultNotify:(AccusationDealResultOC)result userID:(NSString*)userID accusationTime:(unsigned int)accusationTime{
    
}


#pragma mark - FlutterStreamHandler
- (FlutterError*)onListenWithArguments:(id)arguments
                             eventSink:(FlutterEventSink)eventSink {
    self.eventSink = eventSink;
    //    [[UIDevice currentDevice] setBatteryMonitoringEnabled:YES];
    //    [self sendBatteryStateEvent];
    //    [[NSNotificationCenter defaultCenter]
    //     addObserver:self
    //     selector:@selector(onBatteryStateDidChange:)
    //     name:UIDeviceBatteryStateDidChangeNotification
    //     object:nil];
    return nil;
}

- (FlutterError* _Nullable)onCancelWithArguments:(id _Nullable)arguments{
    return nil;
}

@end
